lastmessage = {}
messagesduplicated = {}
canwrite = {}
slowdown = {}
Time = 0

function Initialize(Plugin)
	Plugin:SetName("NoSPAM");
	Plugin:SetVersion(1);
	
	cPluginManager:AddHook(cPluginManager.HOOK_CHAT, OnChat);
	cPluginManager:AddHook(cPluginManager.HOOK_TICK, OnTick);
	cPluginManager:AddHook(cPluginManager.HOOK_PLAYER_DESTROYED, OnPlayerDestroyed);

	LOG("Initialized " .. Plugin:GetName() .. " v." .. Plugin:GetVersion());
	return true;
end



function OnChat(Player, Message)
    if (not(Player:HasPermission("nospam.bypass"))) then
        if Message == lastmessage[Player:GetName()] then
            Player:SendMessageWarning(cChatColor.Red.. "Please don't send duplicated messages, you can be " ..cChatColor.Red.. "kicked for spamming")
            if messagesduplicated[Player:GetName()] == nil then
                messagesduplicated[Player:GetName()] = 1
            end
            if messagesduplicated[Player:GetName()] == 3 then
                messagesduplicated[Player:GetName()] = nil
                Player:GetClientHandle():Kick("Spammer detected!")
            else
                messagesduplicated[Player:GetName()] = messagesduplicated[Player:GetName()] + 1
            end
            return true
        elseif canwrite[Player:GetName()] == false then
            Player:SendMessageWarning(cChatColor.Red.. "Please slow down chat, you can be kicked " ..cChatColor.Red.. "for spamming")
            if slowdown[Player:GetName()] == nil then
                slowdown[Player:GetName()] = 1
            end
            if slowdown[Player:GetName()] == 2 then
                slowdown[Player:GetName()] = nil
                Player:GetClientHandle():Kick("Spammer detected!")
            else
                slowdown[Player:GetName()] = slowdown[Player:GetName()] + 1
            end
            return true
        else
            lastmessage[Player:GetName()] = Message
            messagesduplicated[Player:GetName()] = nil
            canwrite[Player:GetName()] = false
            slowdown[Player:GetName()] = 0
        end
    end    
end

function OnTick(TimeDelta)
	if Time == 20 then
		Time = 0
		local ForEachPlayer = function(Player)
			canwrite[Player:GetName()] = true
		end
		cRoot:Get():ForEachPlayer(ForEachPlayer)
	else
		Time = Time + 1
	end
end

function OnPlayerDestroyed(Player)
    lastmessage[Player:GetName()] = nil
    messagesduplicated[Player:GetName()] = nil
    canwrite[Player:GetName()] = true
    slowdown[Player:GetName()] = 0
end
    